/*
 *  Copyright (c) 2021 NetEase, Inc.  All rights reserved.
 *  Use of this source code is governed by a MIT license that can be found in the LICENSE file
 */

package com.netease.nos.model;


import com.netease.nos.NosPlugin;

/**
 * Created by hzsunyj on 2020/6/10.
 */
public class NosUploadState {

    String key;

    State state;

    double percent;

    String url;

    int code;

    String response;

    private NosUploadState(State state, String key) {
        this.state = state;
        this.key = key;
    }

    public static NosUploadState progressState(String key, long current, long total) {
        NosUploadState nosUploadState = new NosUploadState(State.uploading, key);
        nosUploadState.percent = (current * 1.0) / total;
        return nosUploadState;
    }

    public static NosUploadState successState(String key, String url) {
        NosUploadState nosUploadState = new NosUploadState(State.uploadOK, key);
        nosUploadState.url = url;
        return nosUploadState;
    }

    public static NosUploadState failState(String key, int code, String response) {
        NosUploadState nosUploadState = new NosUploadState(State.uploadFail, key);
        nosUploadState.code = code;
        nosUploadState.response = response;
        return nosUploadState;
    }

    public static NosUploadState cancelState(String key) {
        NosUploadState nosUploadState = new NosUploadState(State.uploadCancel, key);
        return nosUploadState;
    }

    public NosPlugin.MapBuilder toJson(NosPlugin.MapBuilder builder) {
        builder.put("key", key);
        builder.put("state", state.ordinal());
        builder.put("percent", percent);
        builder.put("url", url);
        builder.put("code", code);
        builder.put("response", response);
        return builder;
    }
}
