/*
 *  Copyright (c) 2021 NetEase, Inc.  All rights reserved.
 *  Use of this source code is governed by a MIT license that can be found in the LICENSE file
 */

package com.netease.nos.thread;

import android.os.Handler;
import android.os.Looper;

public class HandlerUtils {
    private static Handler handler = new Handler(Looper.getMainLooper());

    public static Handler getMainThreadHandler(){
        return handler;
    }

    public static void runOnUiThread(Runnable runnable){
        handler.post(runnable);
    }

    public static void runOnUiThreadDelay(Runnable runnable, long delayMillis){
        handler.postDelayed(runnable,delayMillis);
    }

    public static void removeUiRunnable(Runnable runnable){
        handler.removeCallbacks(runnable);
    }

    public static void runOnOtherThread(Runnable runnable){
        ExecutorUtils.getExecutor().execute(runnable);
    }
}
