//
//  NSDictionary+NTESJson.m
//  NIM
//
//  Created by amao on 13-7-12.
//  Copyright (c) 2013年 Netease. All rights reserved.
//

#import "NSDictionary+NIMF.h"

@implementation NSDictionary (NIMJson)

- (NSString *)NIMFjsonString: (id)key
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]])
    {
        return object;
    }
    else if([object isKindOfClass:[NSNumber class]])
    {
        return [object stringValue];
    }
    return nil;
}

- (NSDictionary *)NIMFjsonDict: (id)key
{
    id object = [self objectForKey:key];
    return [object isKindOfClass:[NSDictionary class]] ? object : nil;
}


- (NSArray *)NIMFjsonArray: (id)key
{
    id object = [self objectForKey:key];
    return [object isKindOfClass:[NSArray class]] ? object : nil;

}

- (NSArray *)NIMFjsonStringArray: (id)key
{
    NSArray *array = [self NIMFjsonArray:key];
    BOOL invalid = NO;
    for (id item in array)
    {
        if (![item isKindOfClass:[NSString class]])
        {
            invalid = YES;
        }
    }
    return invalid ? nil : array;
}

- (BOOL)NIMFjsonBool: (id)key
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]] ||
        [object isKindOfClass:[NSNumber class]])
    {
        return [object boolValue];
    }
    return NO;
}

- (BOOL)NIMFjsonBool:(id)key
        defaultValue:(BOOL)value
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]] ||
        [object isKindOfClass:[NSNumber class]])
    {
        return [object boolValue];
    }
    return value;
}


- (NSInteger)NIMFjsonInteger: (id)key
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]] ||
        [object isKindOfClass:[NSNumber class]])
    {
        return [object integerValue];
    }
    return 0;
}

- (long long)NIMFjsonLongLong: (id)key
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]] ||
        [object isKindOfClass:[NSNumber class]])
    {
        return [object longLongValue];
    }
    return 0;
}

- (unsigned long long)NIMFjsonUnsignedLongLong:(id)key
{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSNumber class]])
    {
        return [object unsignedLongLongValue];
    }
    if ([object isKindOfClass:[NSString class]]) {
        return [object longLongValue];
    }
    return 0;
}


- (double)NIMFjsonDouble: (id)key{
    id object = [self objectForKey:key];
    if ([object isKindOfClass:[NSString class]] ||
        [object isKindOfClass:[NSNumber class]])
    {
        return [object doubleValue];
    }
    return 0;
}

@end
