//
//  NSString+NIM.m
//  NIMLib
//
//  Created by amao on 2/9/15.
//  Copyright (c) 2015 Netease. All rights reserved.
//

#import "NSString+NIMF.h"
#import <sys/sysctl.h>

@implementation NSString (NIMF)

- (NSString *)nimf_urlEncodeString{
    NSString *encodedString = (NSString *)
    CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                              (CFStringRef)self,
                                                              NULL,
                                                              (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                              kCFStringEncodingUTF8));
    
    return encodedString;
}

- (NSString *)nimf_urlDecodeString{
    NSString *decodedString  = (__bridge_transfer NSString *)CFURLCreateStringByReplacingPercentEscapesUsingEncoding(NULL,
                                                                                                                     (__bridge CFStringRef)self,
                                                                                                                     CFSTR(""),
                                                                                                                     CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));
    return decodedString;
}

+ (NSString *)nimf_deveicInfo {
    int mib[2];
    size_t len;
    char *machine;

    mib[0] = CTL_HW;
    mib[1] = HW_MACHINE;
    sysctl(mib, 2, NULL, &len, NULL, 0);
    machine = malloc(len);
    sysctl(mib, 2, machine, &len, NULL, 0);

    NSString *platform = [NSString stringWithCString:machine encoding:NSASCIIStringEncoding];
    free(machine);

    if ([platform isEqualToString:@"iPhone1,1"]) return @"iPhone 2G (A1203)";
    if ([platform isEqualToString:@"iPhone1,2"]) return @"iPhone 3G (A1241/A1324)";
    if ([platform isEqualToString:@"iPhone2,1"]) return @"iPhone 3GS (A1303/A1325)";
    if ([platform isEqualToString:@"iPhone3,1"]) return @"iPhone 4 (A1332)";
    if ([platform isEqualToString:@"iPhone3,2"]) return @"iPhone 4 (A1332)";
    if ([platform isEqualToString:@"iPhone3,3"]) return @"iPhone 4 (A1349)";
    if ([platform isEqualToString:@"iPhone4,1"]) return @"iPhone 4S (A1387/A1431)";
    if ([platform isEqualToString:@"iPhone5,1"]) return @"iPhone 5 (A1428)";
    if ([platform isEqualToString:@"iPhone5,2"]) return @"iPhone 5 (A1429/A1442)";
    if ([platform isEqualToString:@"iPhone5,3"]) return @"iPhone 5c (A1456/A1532)";
    if ([platform isEqualToString:@"iPhone5,4"]) return @"iPhone 5c (A1507/A1516/A1526/A1529)";
    if ([platform isEqualToString:@"iPhone6,1"]) return @"iPhone 5s (A1453/A1533)";
    if ([platform isEqualToString:@"iPhone6,2"]) return @"iPhone 5s (A1457/A1518/A1528/A1530)";
    if ([platform isEqualToString:@"iPhone7,1"]) return @"iPhone 6 Plus (A1522/A1524)";
    if ([platform isEqualToString:@"iPhone7,2"]) return @"iPhone 6 (A1549/A1586)";
    if ([platform isEqualToString:@"iPhone8,1"]) return @"iPhone 6s (A1633/A1688/A1691/A1700)";
    if ([platform isEqualToString:@"iPhone8,2"]) return @"iPhone 6s Plus (A1634/A1687/A1690/A1699)";
    //http://www.iphonehacks.com/download-iphone-ios-firmware 添加iphone7 和SE
    if ([platform isEqualToString:@"iPhone8,4"]) return @"iPhone SE";
    if ([platform isEqualToString:@"iPhone9,1"]) return @"iPhone 7 (CDMA)";
    if ([platform isEqualToString:@"iPhone9,2"]) return @"iPhone 7 Plus (CDMA)";
    if ([platform isEqualToString:@"iPhone9,3"]) return @"iPhone 7 (GSM)";
    if ([platform isEqualToString:@"iPhone9,4"]) return @"iPhone 7 Plus (GSM)";
    if ([platform isEqualToString:@"iPhone10,1"]) return @"iPhone 8 (CDMA)";
    if ([platform isEqualToString:@"iPhone10,4"]) return @"iPhone 8 (GSM)";
    if ([platform isEqualToString:@"iPhone10,5"]) return @"iPhone 8 Plus (GSM)";
    if ([platform isEqualToString:@"iPhone10,2"]) return @"iPhone 8 Plus (CDMA)";
    if ([platform isEqualToString:@"iPhone10,3"]) return @"iPhone X (CDMA)";
    if ([platform isEqualToString:@"iPhone10,6"]) return @"iPhone X (GSM)";
    //2018
    if ([platform isEqualToString:@"iPhone11,2"]) return @"iPhone XS (A1920/A2097/A2098/A2100)";
    if ([platform isEqualToString:@"iPhone11,4"]) return @"iPhone XS Max (A2104)";
    if ([platform isEqualToString:@"iPhone11,6"]) return @"iPhone XS Max (A1921/A2101/A2102)";
    if ([platform isEqualToString:@"iPhone11,8"]) return @"iPhone XR (A1984/A2105/A2106/A2108)";

    //CDMA与GSM的区别 https://zhidao.baidu.com/question/14907054.html

    //iPod Touch
    if ([platform isEqualToString:@"iPod1,1"])   return @"iPod Touch 1G (A1213)";
    if ([platform isEqualToString:@"iPod2,1"])   return @"iPod Touch 2G (A1288)";
    if ([platform isEqualToString:@"iPod3,1"])   return @"iPod Touch 3G (A1318)";
    if ([platform isEqualToString:@"iPod4,1"])   return @"iPod Touch 4G (A1367)";
    if ([platform isEqualToString:@"iPod5,1"])   return @"iPod Touch 5G (A1421/A1509)";
    if ([platform isEqualToString:@"iPod7,1"])   return @"iPod Touch 6G (A574)";

    //iPad 1
    if ([platform isEqualToString:@"iPad1,1"])   return @"iPad 1 (A1219/A1337)";

    //iPad 2
    if ([platform isEqualToString:@"iPad2,1"])   return @"iPad 2 (A1395)";
    if ([platform isEqualToString:@"iPad2,2"])   return @"iPad 2 (A1396)";
    if ([platform isEqualToString:@"iPad2,3"])   return @"iPad 2 (A1397)";
    if ([platform isEqualToString:@"iPad2,4"])   return @"iPad 2 (A1395+New Chip)";

    //iPad Mini
    if ([platform isEqualToString:@"iPad2,5"])   return @"iPad Mini 1 (A1432)";
    if ([platform isEqualToString:@"iPad2,6"])   return @"iPad Mini 1 (A1454)";
    if ([platform isEqualToString:@"iPad2,7"])   return @"iPad Mini 1 (A1455)";

    //iPad 3
    if ([platform isEqualToString:@"iPad3,1"])   return @"iPad 3 (A1416)";
    if ([platform isEqualToString:@"iPad3,2"])   return @"iPad 3 (A1403)";
    if ([platform isEqualToString:@"iPad3,3"])   return @"iPad 3 (A1430)";

    //iPad 4
    if ([platform isEqualToString:@"iPad3,4"])   return @"iPad 4 (A1458)";
    if ([platform isEqualToString:@"iPad3,5"])   return @"iPad 4 (A1459)";
    if ([platform isEqualToString:@"iPad3,6"])   return @"iPad 4 (A1460)";

    //iPad Air
    if ([platform isEqualToString:@"iPad4,1"])   return @"iPad Air (A1474)";
    if ([platform isEqualToString:@"iPad4,2"])   return @"iPad Air (A1475)";
    if ([platform isEqualToString:@"iPad4,3"])   return @"iPad Air (A1476)";

    //iPad Mini 2
    if ([platform isEqualToString:@"iPad4,4"])   return @"iPad Mini 2 (A1489)";
    if ([platform isEqualToString:@"iPad4,5"])   return @"iPad Mini 2 (A1490)";
    if ([platform isEqualToString:@"iPad4,6"])   return @"iPad Mini 2 (A1491)";

    //iPad Mini 3
    if ([platform isEqualToString:@"iPad4,7"])   return @"iPad Mini 3 (A1599)";
    if ([platform isEqualToString:@"iPad4,8"])   return @"iPad Mini 3 (A1600)";
    if ([platform isEqualToString:@"iPad4,9"])   return @"iPad Mini 3 (A1601)";

    //iPad Mini 3
    if ([platform isEqualToString:@"iPad5,1"])   return @"iPad Mini 4 (A1538)";
    if ([platform isEqualToString:@"iPad5,2"])   return @"iPad Mini 4 (A1550)";

    //https://stackoverflow.com/questions/11197509/how-to-get-device-make-and-model-on-ios
    //iPad AIR 2
    if ([platform isEqualToString:@"iPad5,3"])   return @"iPad Air 2 (A1566)";
    if ([platform isEqualToString:@"iPad5,4"])   return @"iPad Air 2 (A1567)";

    // iPad PRO 9.7
    if ([platform isEqualToString:@"iPad6,3"])   return @"iPad Pro 9.7 (A1673)";
    if ([platform isEqualToString:@"iPad6,4"])   return @"iPad Pro 9.7 (A1674)";
    if ([platform isEqualToString:@"iPad6,4"])   return @"iPad Pro 9.7 (A1675)";

    //iPad PRO 12.9
    if ([platform isEqualToString:@"iPad6,7"])   return @"iPad Pro 12.9 (A1584)";
    if ([platform isEqualToString:@"iPad6,8"])   return @"iPad Pro 12.9 (A1652)";

    //iPad (5th generation)
    if ([platform isEqualToString:@"iPad6,11"])   return @"iPad 5 (A1822)";
    if ([platform isEqualToString:@"iPad6,12"])   return @"iPad 5 (A1823)";

    //iPad PRO 12.9 (2nd Gen)
    if ([platform isEqualToString:@"iPad7,1"])   return @"iPad Pro 2 12.9 (A1670)";
    if ([platform isEqualToString:@"iPad7,2"])   return @"iPad Pro 2 12.9 (A1671)";
    if ([platform isEqualToString:@"iPad7,2"])   return @"iPad Pro 2 12.9 (A1821)";

    //iPad PRO 10.5
    if ([platform isEqualToString:@"iPad7,3"])   return @"iPad Pro 10.5 (A1701)";
    if ([platform isEqualToString:@"iPad7,4"])   return @"iPad Pro 10.5 (A1709)";


    if ([platform isEqualToString:@"i386"])      return @"iPhone Simulator";
    if ([platform isEqualToString:@"x86_64"])    return @"iPhone Simulator";

    return platform;
}
@end


