//
//  NIMFNosTokenManager.h
//  nos
//
//  Created by 张根宁 on 2020/6/16.
//

#import <Foundation/Foundation.h>

@class NIMFNosToken;

typedef void(^NIMFGetTokenCompletion)(NSError * _Nullable error, NIMFNosToken * _Nullable token);

NS_ASSUME_NONNULL_BEGIN

@protocol NIMFNetworkProtocol <NSObject>

- (NSMutableURLRequest *)request;

- (void)response:(NSDictionary *)responseData error:(NSError *)error;

@end

@interface NIMFNosTokenManager : NSObject

+ (void)request:(id<NIMFNetworkProtocol>)task;

@end

@interface NIMFGetNosTokenTask : NSObject<NIMFNetworkProtocol>

@property (nonatomic, copy) NSString *appkey;
@property (nonatomic, copy) NSString *sdktype;
@property (nonatomic, copy) NSString *sdkver;
@property (nonatomic, copy) NIMFGetTokenCompletion completion;

- (void)resume;

@end



NS_ASSUME_NONNULL_END
