//
//  NIMFNOSConfig.m
//  NOSSDK
//
//  Created by NetEase on 2015/1/15.
//  Copyright (c) 2015年 NetEase. All rights reserved.
//

#import "NIMFNOSConfig.h"

NSString *const kNIMFNOSplatform = @"ios";

const UInt32 kNIMFNOSSoTimeout = 30;

//const UInt32 kNOSConnectionTimeout = 30;

const UInt32 kNIMFNOSChunkSize = 128 * 1024;

const UInt32 kNIMFNOSMoniterInterval = 120;

const UInt32 kNIMFNOSRetryCount = 2;

const UInt32 kNIMFNOSRefreshInterval = 2 * 60 * 60;

NSString *const kNIMFNOSLbsHost = @"https://wannos.127.net";

int const KNIMFNOSLbsHostNum = 4;
NSString const *kNIMFNOSLbsHostArray[KNIMFNOSLbsHostNum] = {
    @"https://wannos.127.net/lbs",
    @"https://wannos-hz.127.net/lbs",
    @"https://wannos-bj.127.net/lbs",
    @"https://wannos-oversea.127.net/lbs"//,
    //@"https://223.252.202.110/lbs"
};

NSString *const kNIMFNOSLbsVersion = @"version=1.0";

static NSArray * kNIMFNOSUploaderDefaultHosts;

@implementation NIMFNOSConfig

+ (void)initialize {
    kNIMFNOSUploaderDefaultHosts = [NSArray arrayWithObjects:@"http://223.252.216.48", nil];
}

+ (NSArray* )uploaderDefaultHosts {
    return kNIMFNOSUploaderDefaultHosts;
}

- (instancetype)init {
    if (self = [super init]) {
        return [self initWithLbsHost:kNIMFNOSLbsHost
                withSoTimeout:kNIMFNOSSoTimeout
        //withConnectionTimeout:kNOSConnectionTimeout
          withRefreshInterval:kNIMFNOSRefreshInterval
                withChunkSize:kNIMFNOSChunkSize
          withMoniterInterval:kNIMFNOSMoniterInterval
               withRetryCount:kNIMFNOSRetryCount];
    }
    return self;
}

- (instancetype)initWithLbsHost:(NSString*) lbsHost
                  withSoTimeout:(UInt32) soTimeout
          //withConnectionTimeout:(UInt32) connectionTimeout
            withRefreshInterval:(UInt32) refreshInterval
                  withChunkSize:(UInt32) chunkSize
            withMoniterInterval:(UInt32) moniterInterval
                 withRetryCount:(UInt32) retryCount {
    if (self = [super init]) {
        _NOSLbsHost = [lbsHost copy];
        _NOSSoTimeout = soTimeout;
        //_NOSConnectionTimeout = connectionTimeout;
        _NOSRefreshInterval = refreshInterval;
        _NOSChunkSize = chunkSize;
        _NOSMoniterInterval = moniterInterval;
        _NOSRetryCount = retryCount;
    }
    return self;
}

/*- (NSString *)lbsUrl {
    NSMutableString * url = [NSMutableString stringWithString:self.NOSLbsHost];
    [url appendString:@"/lbs?"];
    [url appendString:kNIMFNOSLbsVersion];
    return url;
}*/

- (NSString *)statUrl {
    NSMutableString * url = [NSMutableString stringWithString:@"https://"];
    if ([self.NOSLbsHost hasPrefix:@"http://"]) {
        [url appendString: [self.NOSLbsHost substringFromIndex:[@"http://" length]]];
    } else if ([self.NOSLbsHost hasPrefix:@"https://"]) {
        url = [NSMutableString stringWithString:self.NOSLbsHost];
    } else {
        [url appendString:self.NOSLbsHost];
    }
    
    [url appendString:@"/stat/sdk?"];
    [url appendString:kNIMFNOSLbsVersion];
    return url;
}


@end
