#import "NosPlugin.h"
#import "NIMFNosHandler.h"

@interface NosPlugin ()

@property (nonatomic, strong) NIMFNosHandler *nosHandler;
@property (nonatomic, strong) FlutterMethodChannel *channel;

@end

@implementation NosPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:@"nos_sdk"
                                                                binaryMessenger:[registrar messenger]];
    NosPlugin* instance = [[NosPlugin alloc] init];
    instance.channel = channel;
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    BOOL handled = NO;

    handled = [self.nosHandler handleMethodCall:call result:result];
    if (handled) {
        return;
    }

    result(FlutterMethodNotImplemented);
}


- (NIMFNosHandler *)nosHandler {
    if (!_nosHandler) {
        _nosHandler = [[NIMFNosHandler alloc] initWithChannel:_channel];
    }
    return _nosHandler;
}

+ (void)sendResult:(FlutterResult)result error:(NSError *)error {
    FlutterError *flutterError = nil;
    if (error) {
        flutterError = [FlutterError errorWithCode:@(error.code).stringValue
                                           message:error.localizedDescription
                                           details:nil];
    }
    result(flutterError);
}

+ (void)sendResult:(FlutterResult)result object:(id)object {
    result(object);
}

@end
