//
//  NIMFNOSUploader.m
//  nos
//
//  Created by 张根宁 on 2020/6/15.
//

#import "NIMFNOSUploader.h"

@interface NIMFNOSUploader ()
@property (nonatomic,strong)    NSOperationQueue    *uploadQueue;
@end

@implementation NIMFNOSUploader

- (instancetype)init {
    if (self = [super init]) {
        _uploadQueue = [[NSOperationQueue alloc] init];
        [_uploadQueue setMaxConcurrentOperationCount:3];
    }
    return self;
}

- (NSOperation *)upload:(NSString *)filepath
                  token:(NIMFNosToken *)token
               progress:(NIMFHttpProgressBlock)progress
             completion:(NIMFHttpCompletionBlock)completion {
    NIMFNOSUploadTask *task = [NIMFNOSUploadTask task:filepath
                                                token:token
                                             progress:progress
                                           completion:completion];
    [_uploadQueue addOperation:task];
    NSLog(@"add to upload queue, file %@",[filepath lastPathComponent]);
    return task;
}

@end
