//
//  NIMFNosUploadRequest.h
//  nos
//
//  Created by 张根宁 on 2020/6/15.
//

#import <Foundation/Foundation.h>

@class NIMFNosToken;

NS_ASSUME_NONNULL_BEGIN

@interface NIMFNosUploadRequest : NSObject

@property (nonatomic, copy) NSString *receiptId;

@property (nonatomic, copy) NSString *sdkType;

@property (nonatomic, copy) NSString *sdkVersionName;

@property (nonatomic, copy) NSString *path;

@property (nonatomic, copy) NSString *appKey;

- (instancetype)initWithDictionary:(NSDictionary *)dic;

@end


typedef NS_ENUM(NSInteger, NIMFNosUploadState){
    NIMFNosUploadStateLoading = 0,
    NIMFNosUploadStateOK ,
    NIMFNosUploadStateFail,
    NIMFNosUploadStateCancel,
};

@interface NIMFNosUploadResponse : NSObject

@property (nonatomic, copy) NSString *receiptId;

@property (nonatomic, assign) NIMFNosUploadState state;

@property (nonatomic, assign) float percent;

@property (nonatomic, copy) NSString *url;

@property (nonatomic, assign) NSInteger code;

@property (nonatomic, copy) NSString *response;

- (instancetype)initWithRequest:(NIMFNosUploadRequest *)request;

- (NSDictionary *)toDictionary;

- (void)setError:(NSError *)error;

@end

NS_ASSUME_NONNULL_END
