//
//  NIMFNosUploadRequest.m
//  nos
//
//  Created by 张根宁 on 2020/6/15.
//

#import "NIMFNosUploadRequest.h"
#import "NIMFNosToken.h"
#import "NSDictionary+NIMF.h"

@implementation NIMFNosUploadRequest

- (instancetype)initWithDictionary:(NSDictionary *)dic {
    if (self = [super init]) {
        _receiptId = [dic NIMFjsonString:@"receiptId"];
        _sdkType = [dic NIMFjsonString:@"sdkType"];
        _sdkVersionName = [dic NIMFjsonString:@"sdkVersionName"];
        _path = [dic NIMFjsonString:@"path"];
        _appKey = [dic NIMFjsonString:@"appKey"];
    }
    return self;
}

- (NSString *)description {
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    dic[@"receiptId"] = _receiptId ?: @"";
    dic[@"sdkType"] = _sdkType ?: @"";
    dic[@"sdkVersionName"] = _sdkVersionName ?: @"";
    dic[@"path"] = _path ?: @"";
    dic[@"appKey"] = _appKey;
    return [dic description];
}

@end

@implementation NIMFNosUploadResponse

- (instancetype)initWithRequest:(NIMFNosUploadRequest *)request {
    if (self = [super init]) {
        _receiptId = request.receiptId;
    }
    return self;
}

- (void)setError:(NSError *)error {
    _state = NIMFNosUploadStateFail;
    _code = error.code;
    _response = error.userInfo[NSLocalizedDescriptionKey];
}

- (NSDictionary *)toDictionary {
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    dic[@"receiptId"] = _receiptId ?: @"";
    dic[@"state"] = @(_state);
    switch (_state) {
        case NIMFNosUploadStateLoading:
        {
            dic[@"percent"] = @(_percent);
            break;
        }
        case NIMFNosUploadStateOK:
        {
            dic[@"url"] = _url ?: @"";
            break;
        }
        case NIMFNosUploadStateFail:
        {
            dic[@"code"] = @(_code);
            dic[@"response"] = _response ?: @"";
            break;
        }
        case NIMFNosUploadStateCancel:
        default:
            break;
    }
    return dic;
}

@end
