/*
 *  Copyright (c) 2021 NetEase, Inc.  All rights reserved.
 *  Use of this source code is governed by a MIT license that can be found in the LICENSE file
 */

part of nos;

enum UploadState { uploading, uploadOK, uploadFail, uploadCancel }

/// the upload result state
class NosUploadState {
  String? key;

  UploadState? state;

  double? percent;

  String? url;

  int? code;

  String? response;

  static NosUploadState _fromJson(Map<dynamic, dynamic> arg) {
    NosUploadState nosUploadState = NosUploadState();
    nosUploadState.key = arg["key"];
    var index = arg['state'];
    UploadState state = index >= 0 && index < UploadState.values.length ? UploadState.values[index] : UploadState.uploadFail;
    nosUploadState.state = state;
    switch (state) {
      case UploadState.uploading:
        nosUploadState.percent = arg['percent'];
        break;
      case UploadState.uploadOK:
        nosUploadState.url = arg['url'];
        break;
      case UploadState.uploadFail:
        nosUploadState.code = arg['code'];
        nosUploadState.response = arg['response'];
        break;
      case UploadState.uploadCancel:
        break;
    }
    return nosUploadState;
  }
}
